const wsPORT_OFFSET_CONTROL			= 9;

const wsContext = {
	url : 'ws://localhost',
	port : 20000,
	key : 'key',

	mapCommand : new Map(),
	mapControl : new Map(),
};

wsContext.OpenWebSocketCommand = function(fnOpen=undefined, fnClose=undefined)
{
	wsContext.wsCommand = new WebSocket(wsContext.url+':'+(wsContext.port).toString());
	
	if (fnOpen != undefined)
		wsContext.wsCommand.onopen = fnOpen;

	wsContext.wsCommand.onmessage = function(evt) { 
		var objJSON = null;
		
		try 
		{
			objJSON = JSON.parse(evt.data);
		} 
		catch (e) 
		{
			alert("Parsing error data :"+evt.data);
			alert("Parsing error:"+e);
			return;
		}

		if (objJSON && typeof objJSON === "object") 
		{
            const typeObj = typeof objJSON[wsContext.key];
            if (typeObj === "string" || typeObj === "number")
            {
                const fn = wsContext.mapCommand.get(objJSON[wsContext.key]);
                if (fn && typeof fn === "function")
                {
                    fn(objJSON);
                }
                else 
                {
                    const fnDefault = wsContext.mapCommand.get('*');
                    if (fnDefault && typeof fnDefault === "function")
                    {
                        fnDefault(objJSON);
                    }
                }
            }
		}
	}
	
	if (fnClose != undefined)
		wsContext.wsCommand.onclose = fnClose;
	else
		wsContext.wsCommand.onclose = function()	{ wsContext.wsCommand = null; }
}

wsContext.OpenWebSocketControl = function(fnOpen=undefined, fnClose=undefined)
{
	wsContext.wsControl = new WebSocket(wsContext.url+':'+(wsContext.port+wsPORT_OFFSET_CONTROL).toString());
	
	if (fnOpen != undefined)
		wsContext.wsControl.onopen = fnOpen;

	wsContext.wsControl.onmessage = function(evt) { 
		var objJSON = null;
		
		try 
		{
			objJSON = JSON.parse(evt.data);
		} 
		catch (e) 
		{
			alert("Parsing error data :"+evt.data);
			alert("Parsing error:"+e);
			return;
		}

		if (objJSON && typeof objJSON === "object" && typeof objJSON.key === "string") 
		{
			const fn = wsContext.mapControl.get(objJSON.key);
			if (fn && typeof fn === "function")
				fn(objJSON);
		}
	}
	
	if (fnClose != undefined)
		wsContext.wsControl.onclose = fnClose;
	else
		wsContext.wsControl.onclose = function() { wsContext.wsControl = null; }
}

