function OnOpenWebSocketControl()
{
	RefreshWebSocketControl();
}

function OnNotifyControlConnection(objJSON) 
{
//	alert("OnNotifyControlConnection :"+JSON.stringify(objJSON));
	
	const arrayWebSocketServer = objJSON.web_socket_server;
	if (typeof arrayWebSocketServer === 'object')
	{
		var html = '';
		for (let i=0;i<arrayWebSocketServer.length;i++)
		{
			html += '<tr>';
			html += '<td>'+arrayWebSocketServer[i].name+'</td>';
			html += '<td>'+arrayWebSocketServer[i].port+'</td>';
			html += '<td>'+arrayWebSocketServer[i].nb+'</td>';
			
			if (typeof arrayWebSocketServer[i].cb !== "undefined")
			{
				html += '<td>'+arrayWebSocketServer[i].cb+' [ov='+arrayWebSocketServer[i].cb_overflow+']</td>';
			}
			
			html += '</tr>';
		}
		document.getElementById("web_socket_server").innerHTML = html;
	}

	const arraySocketServer = objJSON.socket_server;
	if (typeof arraySocketServer === 'object')
	{
		var html = '';
		for (let i=0;i<arraySocketServer.length;i++)
		{
			html += '<tr>';
			html += '<td>'+arraySocketServer[i].name+'</td>';
			html += '<td>'+arraySocketServer[i].hostname+'</td>';
			html += '<td>'+arraySocketServer[i].port+'</td>';
			html += '<td>'+arraySocketServer[i].nb+'</td>';
			html += '</tr>';
		}
		document.getElementById("socket_server").innerHTML = html;
	}
}

function RefreshWebSocketControl()
{
	if (typeof(wsContext.wsControl) != null)
	{
		if (wsContext.timerCurrent == 0)
		{
			const cmd = { key : '[connection]' };
			wsContext.wsControl.send(JSON.stringify(cmd));
		}

		document.getElementById("refresh_timer").innerHTML = "next refresh "+((wsContext.timerMax-wsContext.timerCurrent)/1000).toString()+" (s) ...";

		wsContext.timerCurrent += 1000;
		if (wsContext.timerCurrent >= wsContext.timerMax)
			wsContext.timerCurrent = 0;
		
		window.setTimeout(RefreshWebSocketControl, 1000);
	}
}

function stop_robot()
{
	const cmd = { key : '[stop]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function restart_websockets()
{
	const cmd = { key : '[restart_websockets]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function restart_sockets()
{
	const cmd = { key : '[restart_sockets]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function stop_sockets()
{
	const cmd = { key : '[stop_sockets]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function start_sockets()
{
	const cmd = { key : '[start_sockets]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function reset_sockets()
{
	const cmd = { key : '[reset_sockets]' };
	wsContext.wsControl.send(JSON.stringify(cmd));
}

function Init()
{
	wsContext.lang = 'fr';
	wsContext.url = wsParams.url;
	wsContext.port = wsParams.port;
	
	wsContext.timerCurrent = 0;
	wsContext.timerMax = 5000;
		
	wsContext.mapControl.set('[connection]', OnNotifyControlConnection);
	wsContext.OpenWebSocketControl(OnOpenWebSocketControl);
}
